%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Octave 5.2.0, Tue Apr 07 18:34:28 2020 GMT <unknown@DESKTOP-KK5256M>
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Load signal and control Library
pkg load signal
pkg load control

% Poles in complex domain
aRoots = [ 0.5*exp(j*0.2) 0.5*exp(-j*0.2) ]

% polynomial coefficients from polynomial roots
a = poly(aRoots)

format long
a = poly(aRoots)

% help for freqz function (frequency responce)
help freqz

% frequency responce of the only poles Linear time invariant system (LTI)
% y[n] = x[n] -a[2]*y[n-1]-a[3]*y[n-2]
freqz(1,a)


% Poles in complex domain inside and near to the unit cycle
aRoots = [ 0.95*exp(j*0.2) 0.95*exp(-j*0.2) ]

% polynomial coefficients from polynomial roots
a = poly(aRoots)

% frequency responce of the only poles Linear time invariant system (LTI)
% y[n] = x[n] -a[2]*y[n-1]-a[3]*y[n-2]
freqz(1,a)

% Poles in complex domain inside and very close to the unit cycle
aRoots = [ 0.99*exp(j*0.2) 0.99*exp(-j*0.2) ]

a = poly(aRoots)

% frequency responce of the only poles Linear time invariant system (LTI)
% y[n] = x[n] -a[2]*y[n-1]-a[3]*y[n-2]
freqz(1,a)
figure

%Positions of the poles in the complex plain
zplane(1,a)

bRoots = [ 0.95*exp(j*0.2) 0.95*exp(-j*0.2) ]
b = poly(bRoots)
zplane(b,a)
figure
freqz(b,a)

% frequency responce of the secong order zero-poles LTI, sampling frequency 2000 Hz
% y[n] = b(1)*x[n] +b(2)*x[n-1] -a[2]*y[n-1]-a[3]*y[n-2]
freqz(b,a,1000,2000)

% More accurate frequency responce of the secong order zero-poles LTI,sampling frequency 2000 Hz
% y[n] = b(1)*x[n] +b(2)*x[n-1] -a[2]*y[n-1]-a[3]*y[n-2]
freqz(b,a,100000,2000)

%  complex frequency response H, at frequencies An,sampling frequency 2000 Hz
[H,An] = freqz(b,a,1000000,2000) ;


% Linear filter with complex coefficients
bRoots=[ exp(j*pi) ]
poly([ exp(j*pi) ])
bRoots
ploy(bRoots)

% A very simple low pass filter
aRoots = [ 0.6 0.7*exp(0.2*j) 0.7*exp(-0.2*j) ]
figure
a = poly(aRoots)
zplane(1,a)
figure
freqz(1,a)

% Low-pass filter design using function fir1 at 0.1 normalized frequncy
% Other types of filters:  "low", "high", "stop", "pass", "bandpass"
b = fir1(0.2,'low');

help fir1
b = fir1(10,0.2,'low')

% Low-pass filter @50Hz, sampling frequency of 1000 Hz
b = fir1(10,50/1000,'low')
close all
clear all

% Low-pass filter @50Hz, sampling frequency of 1000 Hz
b = fir1(10,50/1000,'low')

%Positions of the zeros in the complex plain
freqz(b,1)


b = fir1(100,50/1000,'low')
% frequency responce of the low-pass LTI
freqz(b,1)

% frequency responce of the low-pass LTI, sampling frequency 2000 Hz, frequncy accuracy 1Hz
freqz(b,1,2000,2000)

%Positions of the zeros in the complex plain
figure
zplane(b,1)


b = fir1(20,50/1000,'low')
zplane(b,1)

freqz(b,1,2000,2000)
b = fir1(2000,50/1000,'low')
freqz(b,1,2000,2000)

% frequency responce of the high-pass 300 zeros LTI, sampling frequency 2000 Hz, frequncy cutoff 200Hz
b = fir1(300,200/1000,'high') ;
freqz(b,1,2000,2000)
figure
freqz(b,1,2000,2000)
zplane(b,1)


% frequency responce of the bandpass [200 300], 300 zeros LTI, sampling frequency 2000 Hz
b = fir1(300,[200/1000 300/1000],'pass') ;
close all
zplane(b,1)
figure
freqz(b,1,2000,2000)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Filtering ECG .....
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load ECGx1
plot(x)

% Fast Fourier Transform (FFT)
fx = fft(x) ;
plot(abs(fx))
semilogy(abs(fx))
x1 = x - mean(x) ; 
hold on
figure
hold off
plot(x)
hold off
plot(x1,'r')
plot(x)
hold on
plot(x1,'r')

% DC value of the FFT
fx(1)
fx(2)
fx(3500)
fx(3)
fx(3499)

% Remove Dc component in the FFT array
fx(1)=0 ;
figure
plot(y)
% Inverse FFT, reconstruct the new signal without Dc component 
y = real(ifft(fx));
plot(y)
figure(2)
hold on
plot(y,'k')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Octave 5.2.0, Tue Apr 07 18:34:28 2020 GMT <unknown@DESKTOP-KK5256M>
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load "EEG-128Hz"
x = eeg_close_ubicomp_8sub(20000:40000-1,1);
plot(x)
fx=abs(fft(x));
plot(fx)
figure
semilogy(fx)

% Remove DC in the time domain
x0 = x - mean(x) ;
fx0=abs(fft(x0));

% Plot Remove DC in the time domain
semilogy(fx0)

% Set Dc component of the EEG to 10
x0 = x - mean(x) + 10.0 ;
fx0=abs(fft(x0));
semilogy(fx0)
help axis
axis([0,128])
semilogy(fx0)
t=0:1/Fs:(length(y)-1)/Fs;
Fs=128
t=0:1/Fs:(length(fx)-1)/Fs;

% Plot the half of the abs fft of the signal. Horizontal the actual frequencies...
semilogy(fx0(1:length(fx0)/2),t(1:length(fx0)/2))
semilogy(t(1:10000),fx0(1:10000))


x0 = x - mean(x) +10.0 ;
fx0=fft(x0);

% Keep frequncy components (less than 1Hz and greater than 4) in the frequency domain ....
xmn = 20000/128+1
xma = 4*20000/128+1
fx(1:xmn) = 0 ;
fx(xma:20000-xma+1) = 0 ;
fx(20000-xmn+1:20000) = 0 ;
plot(abs(fx))

% remove high frequncy components ( greater than 4) in the frequency domain ....
fx0=fft(x0);
fx(xma+1:20000-xma+1) = 0 ;
plot(abs(fx))
figure
plot(abs(fx0))


%% Abs value of the fft for a EEG signal, real frequencies in the x axes
load "EEG-128Hz"
x = eeg_close_ubicomp_8sub(10000:20000-1,3) ;
plot(x)
x = x - mean(x) ;
fx = ffx(x) ;
plot(abs(fx))
plot(abs(fx(1:5000)))
help linspace
t=linspace(0,64,5000) ;
plot(t,abs(fx(1:5000)))
plot(abs(fx))


% Frequency equivalent at each array position
st = 10000/128
fx(1:st+1) = 0;
plot(fx)
plot(abs(fx))
% Remove all high frequencies, greater than 4Hz
fx(floor(1+4*st):floor(10000-4*st)) = 0;
plot(abs(fx))

% Estimate Delta components (greater than 1Hz and less than 4) in the frequency domain ....
st = 10000/128
fx = ffx(x) ;
fx(1:st+1) = 0;
plot(fx)
plot(abs(fx))
fx(floor(1+4*st):floor(10000-4*st)) = 0;
plot(abs(fx))
fx(floor(10000-st):10000) = 0;
plot(abs(fx))
delta=real(ifft(fx));
figure
plot(delta(1:2000))


fx=fft(x) ;
% Keep frequncy components (greater than 4Hz and less than 8Hz, theta components) in the frequency domain ....
fx(1:4*st+1) = 0 ;
fx(8*st+1:10000-8*st) = 0;
fx(10000-4*st:10000) = 0;

plot(abs(fx))
theta=real(ifft(fx)) ;
plot(theta)
figure
plot(delta(1:2000))
hold on
plot(theta(1:2000),'r')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Effect of the window size to the frequency accuracy 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = sin((1:100)*2*pi*50/128) ;
plot(y)
figure
plot(y)
%% FFT of a sinus at 50Hz sampling frequency of 128
plot(abs(fft(y)))

%% FFT of a sinus at 30Hz sampling frequency of 128
y = sin((1:100)*2*pi*30/128) ;
plot(abs(fft(y)))
plot(y)

%% FFT of a sinus at 100Hz sampling frequency of 128
%% Aliasing effect
y = sin((1:100)*2*pi*100/128) ;
plot(abs(fft(y)))
plot(y)


%% FFT of two sinus at 30 and 32Hz sampling frequency of 128, 10000 samples in time
y = sin((1:10000)*2*pi*30/128)+sin((1:10000)*2*pi*32/128) ;
plot(abs(fft(y)))

%% FFT of two sinus at 30 and 32Hz sampling frequency of 128, 100 samples in time
y = sin((1:100)*2*pi*30/128)+sin((1:100)*2*pi*32/128) ;
plot(abs(fft(y)))

%% FFT of two sinus at 30 and 31Hz sampling frequency of 128, 100 samples in time
y = sin((1:100)*2*pi*30/128)+sin((1:100)*2*pi*31/128) ;
plot(abs(fft(y)))

%% FFT of two sinus at 30 and 32Hz sampling frequency of 128, 1000 samples in time
y = sin((1:1000)*2*pi*30/128)+sin((1:1000)*2*pi*31/128) ;
plot(abs(fft(y)))



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Window effect ......
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = [zeros(1,10000) sin((1:1000)*2*pi*30/128) zeros(1,10000)]
plot(y)
plot(abs(fft(y)))

y = [zeros(1,1000) sin((1:1000)*2*pi*30/128) zeros(1,1000)]
plot(y)
plot(abs(fft(y)))

z = [ones(1,100) zeros(1,100)]
plot(z)
plot(abs(fft(z)))

z = [ones(1,100) zeros(1,100)]
plot(abs(fft(z)))

z1 = [sin(2*pi*0.1*(1:100)) zeros(1,100)] ;
plot(z1)
plot(abs(fft(z1)))

%% Hanning Window ......
plot(hanning(100))
plot(abs(fft(hanning(100))))

figure, plot(abs(fft(z1)))
plot(abs(fft(hanning(200))))


figure, plot(abs(fft(z1)))
hold on, plot(abs(fft(hanning(200))),'r')
figure(3), hold on, plot(abs(fft(hanning(200))),'r')
close all

% Multiply signal by window
load "EEG-128Hz"
x1 = eeg_close_ubicomp_8sub(10000:20000-1,3) ;
x1 = x1 - mean(x1) ;
zorg = x1 ;
x1 = x1 .* hanning(10000) ;
plot(x1)
hold on 
plot(zorg,'r')
figure
